#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include "vahm32.h"

/*****************************************************************************
 * Fonction BOOL OuvrirLaisonSerie(LPCTSTR lpNomduPort)
 * lpNomduPort : Nom du port  utilis, soit COM1 ou COM2
 *****************************************************************************/
HANDLE OuvrirLiaisonSerie(LPCTSTR lpNomduPort)
{
	DCB	dcb;
	COMMPROP GetCom;
	BOOL bResultat;
	DWORD dwNumChar = 1;
	HANDLE hPort;

	/* Creation de l'objet utilis pour identifie la liaison srie.*/
	hPort = CreateFile(lpNomduPort, GENERIC_READ | GENERIC_WRITE, 0, NULL,
   							  OPEN_EXISTING, 0, NULL);

	/* Initialisation de la taille des buffer d'E/S pour le port srie. */
	bResultat = SetupComm(hPort,1024,1024);
	/* Association d'une structure de controle DCB au port srie. */
 	bResultat = GetCommState(hPort, &dcb);
    /* Association d'une structure de propit DCB au port srie. */
 	bResultat = GetCommProperties(hPort,&GetCom);


	memset(&dcb,0,sizeof(dcb));  //9600 bauds, 1 stop, pas de parit, 8 bits
	dcb.DCBlength = sizeof(dcb);
	dcb.BaudRate = 9600;
	dcb.fBinary = TRUE;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

    /*  Configuration du Port Serie */
	SetCommState(hPort, &dcb);

	return hPort;
}

/*****************************************************************************
 * Fonction BOOL FermerLaisonSerie(HANDLE hPort)
 *****************************************************************************/
void FermerLiaisonSerie(HANDLE hPort)
{
	CloseHandle(hPort);
}

/*****************************************************************************
 * Fonction BOOL FermerLaisonSerie(HANDLE hPort)
 *****************************************************************************/
void Demarrer68HC11(HANDLE hPort)
{
	DWORD										dwNumChar = 1;
	DWORD										dwNumCharEcrits;
	char										szBuffer[1];

	sprintf(szBuffer,"%c",'D');
	WriteFile(hPort, szBuffer, dwNumChar, (LPDWORD)&dwNumCharEcrits, NULL);
}

/*****************************************************************************
 * Fonction de Lecture des capteurs  ultrasons
 *****************************************************************************/
void LectureCapteursUS(HANDLE hPort, float *ustab)
{
	int i, k;
 	float usp[ VAHM32_NBRCAPTSUS ];
 	float vit = (float)34300.0;
	float basetps = (float)32.0e-6;
 	unsigned char reception[ VAHM32_NBRCAPTSUS ];
	char szBuffer[ 1 ];
	DWORD dwNumChar = 1;
	DWORD dwNumCharEcrits;
	DWORD dwNumCharLus;

 	sprintf( szBuffer,"%c",'E' );
 	WriteFile( hPort, szBuffer, dwNumChar, (LPDWORD)&dwNumCharEcrits, NULL );
  	ReadFile( hPort, reception, sizeof(reception), (LPDWORD)&dwNumCharLus, NULL );
	sprintf( szBuffer,"%c",'F' );
 	WriteFile( hPort, szBuffer, dwNumChar, (LPDWORD)&dwNumCharEcrits, NULL );

	for( i = 0; i < VAHM32_NBRCAPTSUS; i++ )
	{
   		usp[i]=(float)(reception[i]);
    }
	for( i = 1; i < VAHM32_NBRCAPTSUS; i++ )
 	{
   		usp[i] = usp[i] * vit * basetps;
	}
	for( k = 0; k <= 3; k++ )
	{
 		ustab[1+4*k] = usp[1+k];
 		ustab[2+4*k] = usp[5+k];
   		ustab[3+4*k] = usp[9+k];
   		ustab[4+4*k] = usp[13+k];
	}
 	for( i = 1; i < VAHM32_NBRCAPTSUS; i++ )
	{
   		if( ustab[i] <= 10 )
      		ustab[i] = 11;
	}
	ustab[0] = usp[0];
}

