#if !defined(_WIN32 )
#include <windows.h>
#include <windowsx.h>
#endif

#if !defined(_EXPORTVAHM32_)
#define EXPORTVAHM32 __declspec( dllexport )
#else
#define EXPORTVAHM32 __declspec( dllimport )
#endif

/*****************************************************************************
 * Constantes
 *****************************************************************************/
/* ERREURS / OK */
#define VAHM32_OK							1	/* Aucun problmes */
#define VAHM32_PROBLEME						2	/* Probleme d'Init */
#define VAHM32_ERREUR						3	/* Erreur */
#define VAHM32_LECTURE_US_IMPOSSIBLE		10	/* Acquisition US Impossible */
#define VAHM32_ECHEC_LIAISON68HC11			20	/* Impossible d'ouvrir la 
												   liaison srie avec 68HC11 */
#define VAHM32_UNILIB_ERREUR				21	/* Impossible d'initialiser
												   la librairie universelle */
#define VAHM32_ODOM_ERREUR					22	/* Erreur  l'initialisation
												   des compteurs */

/* AUTRES */
#define VAHM32_NBRCAPTSUS					17  /* Nombre de capteurs US + 1 */

/*****************************************************************************
 * Prototypes des fonctions de la DLL
 *****************************************************************************/
int EXPORTVAHM32 VAHM32_AProposDe( ); /* informations sur la dll */ 
int EXPORTVAHM32 VAHM32_InitVAHM( );
int EXPORTVAHM32 VAHM32_CloseVAHM( );
int EXPORTVAHM32 VAHM32_LectureUS( float *BufferUS );
int EXPORTVAHM32 VAHM32_AffichageUS( HWND hwnd, int Xorg, int Yorg, float *BufferUS );
DWORD EXPORTVAHM32 VAHM32_CaptureImage( );
int EXPORTVAHM32 VAHM32_SauveImgPGM( BYTE *image, char* nomFichier );
int EXPORTVAHM32 VAHM32_EcritureTension( float v1, float v2 );
int EXPORTVAHM32 VAHM32_LireCodeurs( long *ulCntDrt, long *ulCntGch );
int EXPORTVAHM32 VAHM32_RAZCodeurs( );
int EXPORTVAHM32 VAHM32_SETCodeurs( long ctn1, long ctn2 );


