/***************************************************************************
 *            routineodo.c
 *
 *  Tue Apr 19 10:53:29 2005
 *  Copyright  2005  Yann MORERE
 *  morere@sciences.univ-metz.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 #include <string.h>
#include <glib/gprintf.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "routineodo.h" 


gint config_codeur(gchar * nom_codeur)
{
	/*configuration du codeur*/
// MCR
	//	QDX4 X4_QUAD /* Multiplicateur de résolution, ou désactivation de la 
//				    quadrature : les compteurs sont utilisés comme de 
//					simples compteurs TTL */
//	NrmCnt NORMAL_MODE /* Mode de Comptage */
//	BINCnt BINARY_ENCODING /*Codage BCD ou Binaire */
//IDR
	//	DisIDX INDEX_DISABLED /* Selection de l'action sur le signal Index */
//	NIDX ENABLED /* Polarité du signal Index */
//	CB_UPDN CARRY_BORROW /* Sélection des signaux représentés par FLG1 et FLG2 */
//	on ne met rien par défaut DISABLED /*Gating*/
FILE * codeur;
gchar text[256] ="";
	codeur = fopen(nom_codeur,"wt");
	if (codeur == NULL)
	{
		printf("Erreur ouverture set_codeur %s. Vérifier module pci_quad04", nom_codeur);
		return 1;
	}
		else
	{
		//configuration init vahm set_1: set_1 PR=0  CMR=0x28 IOR=0x47 IDR=0x60, ICR=0x0f, ISR=0x00, PIC_A=0x00, PIC_B=0x00

		gint cmr = CMR((BINCnt+NrmCnt+QDX4)); // 0xb8
		//cmr = 0x28; //init 0x28
		//printf("CMR = %x\n",cmr);
		gint ior = IOR((EnAB+LOL+CB_UPDN)); //0xd1 -> 0xd7 +ABGate
		//ior = 0x47;
		//printf("IOR = %x\n",ior);
		gint idr = IDR((DisIDX+NIDX));
		//idr = 0x60;
		//printf("IDR = %x\n",idr);
		//printf("nom fichier %s\n",nom_codeur);
		g_sprintf(text,"PR=0 CMR=0x%x IOR=0x%x IDR=0x%x\n", cmr, ior, idr);
		/*intialisation des codeurs */
		g_fprintf(codeur, text);
		fclose(codeur);
	}
	return 0;
}

gint init_codeur(gchar * nom_codeur, glong valeur)
{
FILE * codeur;
gchar text[256] ="";
	codeur = fopen(nom_codeur,"wt");
	if (codeur == NULL)
	{
		printf("Erreur ouverture set_codeur %s. Vérifier module pci_quad04", nom_codeur);
		return 1;
	}
		else
	{
		g_sprintf(text,"PR=%ld\n", valeur);
		/*intialisation des codeurs */
		g_fprintf(codeur, text);
		fclose(codeur);
	}

	return 0;
}
glong lectureODO(gchar * nom_codeur, gint sens)
{
	FILE * codeur;
	gchar text[256]="" ;
	glong compteur;
	gint n;
	codeur = fopen(nom_codeur,"rt");
	if (codeur == NULL)
	{
		printf("Erreur ouverture set_codeur %s. Vérifier module pci_quad04", nom_codeur);
		return 0;
	}
		else
	{
		n = fread (text, sizeof(char), 255, codeur);
		if (n < 0)
      		fputs("read() of failed!\n", stderr);
		//g_printf("Valeur lue %s : %s\n",nom_codeur, text);
		fclose(codeur);
		sscanf(text,"%*s %*s %ld", &compteur);
		//le comptage se fait de 0 à  2^24 y pas de -
		if (sens==-1)
			compteur = (glong) ( ( long )( pow( 2,24 ) ) - compteur );
		/*
		nCodeRetour = cbCLoad32( ODOM_BoardNum, COUNT1, ( unsigned long )( - (ctn1 + ( long )( pow( 2,23 ) ) ) ) );
        if( nCodeRetour != 0 )
                return nCodeRetour;
        nCodeRetour = cbCLoad32( ODOM_BoardNum, COUNT2, ( unsigned long )( ctn2 + ( long )( pow( 2,23 ) ) ) );
        if( nCodeRetour != 0 )
                return nCodeRetour;
		*/
		//g_printf("Valeur compteur %s : %ld\n",nom_codeur, compteur);
		return compteur;
	}
}
